/* Memory banks for Ipac HCS12 Board
   (http://www.emacinc.com)

  
  */
MEMORY
{  	
  page0 (rx) : ORIGIN = 0x1000, LENGTH = 256

  /* Use CMD12 Ram for text */
  text  (rx)  : ORIGIN = 0x4000, LENGTH = 16k
  common      : ORIGIN = 0xc000, LENGTH = 12k
  data        : ORIGIN = 0x1100, LENGTH = 11K
  bank0       : ORIGIN = 0xD0000, LENGTH = 16K
  bank1	      : ORIGIN = 0xD4000, LENGTH = 16K
  bank2       : ORIGIN = 0xD8000, LENGTH = 16K
  bank3       : ORIGIN = 0xDC000, LENGTH = 16K
  bank4       : ORIGIN = 0xE0000, LENGTH = 16K
  bank5       : ORIGIN = 0xE4000, LENGTH = 16K
  bank6       : ORIGIN = 0xE8000, LENGTH = 16K
  bank7       : ORIGIN = 0xEC000, LENGTH = 16K
  bank8       : ORIGIN = 0xF0000, LENGTH = 16K
  bank9       : ORIGIN = 0xF4000, LENGTH = 16K
  bank10      : ORIGIN = 0xF8000, LENGTH = 16K
  bank11      : ORIGIN = 0xFC000, LENGTH = 16K
  bank12      : ORIGIN = 0x100000, LENGTH = 16K
  bank13      : ORIGIN = 0x104000, LENGTH = 16K
/*
  bank8       : ORIGIN = 0xE0000, LENGTH = 16K
  bank9       : ORIGIN = 0xE4000, LENGTH = 16K
  bank10      : ORIGIN = 0xE8000, LENGTH = 16K
  bank11      : ORIGIN = 0xEC000, LENGTH = 16K
  bank12      : ORIGIN = 0xF0000, LENGTH = 16K
  bank13      : ORIGIN = 0xF4000, LENGTH = 16K
*/
}


SECTIONS
{

.usrlib :
{
FILL(0xa7)
utils.o(.text)
utils.o(.text.*)
utils.o(.rodata)
utils.o(.rodata.*)
. = ALIGN(2);
} > common

.bank8 :
{
FILL(0xa7)
drivers.o(.text)
drivers.o(.text.*)
/*
drivers.o(.rodata)
drivers.o(.rodata.*)
*/
scheduler.o(.text)
scheduler.o(.text.*)

scheduler.o(.rodata)
scheduler.o(.rodata.*)

. = ALIGN(2);
} > bank8

.bank9 :
{
FILL(0xa7)
main.o(.text)
main.o(.text.*)
rc.o(.text)
rc.o(.text.*)
. = ALIGN(2);
} > bank9


.bank10 :
{
	FILL(0xa7)
	modbus.o(.text)
	modbus.o(.text.*)
. = ALIGN(2);
} > bank10


.text_low :
{
FILL(0xa7)
KEEP (*(.install0)) /* Section should setup the stack pointer. */
KEEP (*(.install1)) /* Place holder for applications. */
KEEP (*(.install2)) /* Optional installation of data sections in RAM. */
KEEP (*(.install3)) /* Placeholder for applications. */
KEEP (*(.install4)) /* Section that calls the main. */
KEEP (*(.init))
indirect.o(.text)
indirect.o(.text.*)
indirect.o(.rodata)
indirect.o(.rodata.*)
. = ALIGN(2);
} > text

.romove :
{
FILL(0xa7)
drivers.o(.rodata)
drivers.o(.rodata.*)
*(.rodata)
*(.rodata.*)
*(.tramp)
*(.tramp.*)
. = ALIGN(2);
} > text

}


/* Setup the stack on the top of the data memory bank.  */
PROVIDE (_stack = 0x3fff);
PROVIDE (_io_ports = 0);
vectors_addr = 0xef80;



