/* param.h */

#ifndef _M68HC12_IPAC_PARAM_H
#define _M68HC12_IPAC_PARAM_H

/* EMAC Ipac  board definitions.  */

#define IPAC

#include "regdefs.h"

#ifndef DEBUG_PORT
#define DEBUG_PORT 0
#endif

#define DIGITALPORTNUM 6
#define IOCNUMPORTS 8
#define PWMNUM 0//not used for this rev of software
#define PWMSYS PWMNUM+IOCNUMPORTS
#define DACPWM0 6
#define DACPWMNUM 2
#define EXDACNUM 4
#define DTOANUM (EXDACNUM+DACPWMNUM)

#undef M6811_DEF_BAUD
#define M6811_DEF_BAUD 0x30            /* 9600 baud.  */

#undef RAM_SIZE
#define RAM_SIZE       0x2000           /* 8Kb of memory  */

#undef ROM_SIZE
#define ROM_SIZE       0x40000           /*256Kb of memory  */

#undef DATA_SIZE
# define DATA_SIZE     RAM_SIZE         /* Data section size.  */

#undef TEXT_SIZE
#define TEXT_SIZE      ROM_SIZE        /* Text section size.  */

#define STATUS_PORT 	PORTE
#define STATUS_CONFIG	DDRE
#define STATUS_MASK 	0x80

#define RTS_ENABLE(port){DDRK|=(1<<port);} //set RTS line to output
#define RTS_ON(port)  	{PORTK&=(~(1<<port));}
#define RTS_OFF(port) 	{PORTK|=(1<<port);}

#define PORT232 0
#define PORT422 1
/* Number of COM Ports */
#define NUM_COMPORTS 2
#define CANMOD_NUM	1		/*number of can modules used*/

#define PortH_ISR()\
if(KEWIFH&INT0)RTCAlarm0ISR();\
if(KEWIFH&INT1)RTCAlarm1ISR();\
if(KEWIFH&0xF0)KeypadISR();


#endif

