/* param.h - 
   Copyright (C) 2000, 2001, 2002 Free Software Foundation, Inc.

This file is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

In addition to the permissions in the GNU General Public License, the
Free Software Foundation gives you unlimited permission to link the
compiled version of this file with other programs, and to distribute
those programs without any restriction coming from the use of this
file.  (The General Public License restrictions do apply in other
respects; for example, they cover modification of the file, and
distribution when not linked into another program.)

This file is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef _M68HC12_RSI_PARAM_H
#define _M68HC12_RSI_PARAM_H

/* RWE Schott Solar RSI board definitions.  */
#define RSI_ARCH

#include "regdefs.h"

#define DIGITALPORTNUM 6
#define IOCNUMPORTS 8
#define PWMNUM 0//not used for this rev of software
#define PWMSYS PWMNUM+IOCNUMPORTS
#define DACPWM0 6
#define DACPWMNUM 2
#define EXDACNUM 4
#define DTOANUM (EXDACNUM+DACPWMNUM)

#undef M6811_DEF_BAUD
#define M6811_DEF_BAUD 0x30            /* 9600 baud.  */

#undef RAM_SIZE
#define RAM_SIZE       0x2000           /* 8Kb of memory  */

#undef ROM_SIZE
#define ROM_SIZE       0x40000           /*256Kb of memory  */

#undef DATA_SIZE
# define DATA_SIZE     RAM_SIZE         /* Data section size.  */

#undef TEXT_SIZE
#define TEXT_SIZE      ROM_SIZE        /* Text section size.  */

#define ATOD_RESOLUTION 1024
#define ANALOG_VCC 		5

#define STATUS_PORT 	PTM
#define STATUS_CONFIG	DDRM
#define STATUS_MASK 	1

#define RTS_ENABLE(port){DDRA=0x03;}
#define RTS_ON(port)  	{if(!port)PORTA=3;}
#define RTS_OFF(port) 	{if(!port)PORTA=0;}

#define PORT232 0
#define PORT422 1
/* Number of COM Ports */
#define NUM_COMPORTS 2

#endif

