/*
 * AD.H
 * Header file for ADC drivers for the uP180
 * EMAC, Inc.  1/11/99
 *
 */

#ifndef _AD_H_
#define _AD_H_
#include "GNU_defs.h"

/* Valid res_modes */
#define HI_RES 1
#define LO_RES 0

/* Valid ad_modes */
#define ONCE	0

/* Number of channels */
#define NUMCHANNELS 8

/* Define Analog to Digital Select */
#define ADSELECT	0x02


/*control defines*/
#define MSBF	0x04
#define UNIP	0x08
#define BIT8	0	
#define POFF	1
#define BIT12	2
#define BIT16	3

#define LTC_CONTROL PORTK
#define LTC_CONFIG 	 DDRK

#define LTC_CS 0x08

#define LTCCS_OFF()	LTC_CONTROL|=LTC_CS
#define LTCCS_ON()  LTC_CONTROL&=(~LTC_CS)

#define LTC_INIT_LINES() {LTC_CONFIG|=LTC_CS;LTCCS_OFF();}


typedef struct AtoDsample{
unsigned int channel[NUMCHANNELS];
}AtoDsample;


/* Function Prototypes */
int __attribute__((far))LTC1290Init(void);
void  __attribute__((far))Select1290(u8 status);
int  __attribute__((far))LTC1290_Read(AtoDsample *sample);

#endif

