#ifndef _PRINT_H_
#define _PRINT_H_
/*!serial console printf
Printf out of a serial port this uses stephane's vsprintf implementation and, as such only supports string and long arguements.
Any module using this call must locate it's constant data in the common section(which is the default linker behavior)
This is because the HC12 GNU compiler cannot pass pointers to constants correctly across banks.
WARNING
This function cannot be called recursively. If this function is used to refresh data on the serial screen(via the real time scheduler for
example) It should be the only thread running that accesses it. This could mean either only giving one thread the ablilty to refresh
the screen or disabling the real time interrupt before and after it's called. The former is a better approach since disabling RTinterrupts
will throw off the schedulers clock.

@param channel the serial port to use PORT232 or PORT422
@param msg the character string
@param ... printf arguements, currently these must be long or string
*/
char __attribute__((far))ser_printf(char channel, const char *msg, ...);

/*!LCD printf
Printf out of the LCD. this uses stephane's vsprintf implementation and, as such only supports string and long arguements.
Any module using this call must locate it's constant data in the common section(which is the default linker behavior)
This is because the HC12 GNU compiler cannot pass pointers to constants correctly across banks.
WARNING
This function cannot be called recursively. If this function is used to refresh data on the serial screen(via the real time scheduler for
example) It should be the only thread running that accesses it. This could mean either only giving one thread the ablilty to refresh
the screen or disabling the real time interrupt before and after it's called. The former is a better approach since disabling RTinterrupts
will throw off the schedulers clock.

@param msg the character string
@param ... printf arguements, currently these must be long or string
*/
char __attribute__((far))LCD_printf(const char *msg, ...);
#endif //_PRINT_H_
