#ifndef _SIGNAL_H_
#define _SIGNAL_H_

#include <gnu_defs.h>
#include <stdio.h>
#include <realtime.h>

typedef volatile struct event{
	u32 signalmask;//signals which can trigger the event
	ptask action;
	taskdata arg;
	volatile struct event *previous;
	volatile struct event *next;
}event;

static inline void fire(event *e){if(e!=NULL)e->action(e->arg);}	

/*!The task lisk head type.
*/
typedef struct eventlist{
u32 signals;//active signal bitmap
u32 signals_needed;//signals required by the list
event *head;
event *tail;
int size;
}eventlist;
/**
 * registered signals
 */
#define SCI0_DATA_RECEIVED 	0x00000001
#define SCI1_DATA_RECEIVED 	0x00000002
#define CAN0_DATA_RECEIVED 	0x00000004
#define CAN1_DATA_RECEIVED 	0x00000008
#define CAN2_DATA_RECEIVED 	0x00000010
#define CAN3_DATA_RECEIVED 	0x00000020
#define CAN4_DATA_RECEIVED 	0x00000040

#define SCI0_DATA_SENT 		0x00001000
#define SCI1_DATA_SENT 		0x00002000
#define CAN0_DATA_SENT 		0x00004000
#define CAN1_DATA_SENT 		0x00008000
#define CAN2_DATA_SENT 		0x00010000
#define CAN3_DATA_SENT 		0x00020000
#define CAN4_DATA_SENT 		0x00040000



event *__attribute__((far))register_event(event *e);
void __attribute__((far))unregister_event(event *e);
void __attribute__((far))throw(int signal);
void __attribute__((far))fire_events(void);

#endif //_EVENTS_H_
