#ifndef _VT100_H_
#define _VT100_H_

#include <init.h>
/*@{*/
/*!VT00 commands
Serial_Send_Byte is used to provide a macro sending the escape character SESC
After that VT100 commands are easily implemented by calling SESC and using ser_printf to provide the specific sequence
*/
#define SESC(port) {Ser_Send_Byte(port, 0x1b);}
#define CLRSCR(port) {SESC(port);ser_printf(port,"[2J");}
#define HVHOME(port) {SESC(port);ser_printf(port,"[f");}
#define CURSORUP(port) {SESC(port);ser_printf(port,"[A");}
#define NEWSCRN(port) {CLRSCR(port);HVHOME(port);}
#define CURSPOS(port,line,column) {SESC(port);ser_printf(port,"[%d;%df",(long)line,(long)column);}
#define SAVE_CURSOR(port) {SESC(port);ser_printf(port,"7");}
#define RESTORE_CURSOR(port) {SESC(port);ser_printf(port,"8");}

#endif //_VT100_H_
