/***************************************************************************
                          CANflect.c  -  CAN reflection 
                             -------------------
    begin                : Thu Oct 11 2005
    email                : ngustavson@emacinc.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <init.h>//needed for ser_printf
#include "CANflect.h"


canmsg messages_rx[QUEUESIZE],messages_tx[QUEUESIZE];

/**
 * Setup a CAN module for reflection
 */
can_module *reflectCAN_setup(int module, unsigned long baud,unsigned long long id,
 unsigned long long mask){
	can_module *CAN = CAN_device(module);
	CAN->baud = baud;
	CAN->id = id;
	CAN->mask = mask;
	CAN->rx.queue = messages_rx;
	CAN->tx.queue = messages_tx;
	CAN->rx.size = CAN->tx.size = QUEUESIZE;
	CANStart(CAN);
	return CAN;
}

/**
 * Parse the CAN queues, if a messages are equal to the reflect message,
 * retransmit them back.
 * if the reflect_message arguement is NULL just reflect everything
 */
int reflectCAN_step(can_module *CAN, char *reflect_message,int sport){	
		canmsg message_in[1];				
		while(CAN->rx.messages){//any new messages?
			if(sport>=0)
				ser_printf(sport,"message in the CAN queue \n\r");
			
			CAN_RX_DISABLE(CAN);//disable reception briefly for safety. 
			CAN_POP(message_in,&CAN->rx);//get message from queue
			CAN_RX_ENABLE(CAN);	
				
			can_print_message(0,message_in);
			
			CAN_TX_DISABLE(CAN);//disable transmission briefly for safety.			
			
			if(reflect_message==NULL)
				CAN_PUSH(&CAN->tx,message_in);//set up transmission
			else	
				if(!strcmp(message_in->data,reflect_message))
					CAN_PUSH(&CAN->tx,message_in);
			
			CAN_TX_ENABLE(CAN);
		}		
					
return 0;	
}
