/***************************************************************************
                          modtest.c  -  modbus example
                             -------------------
    begin                : Tue Feb 14 2006
    email                : support@emacinc.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <init.h>
#include <tasks.h>
#include <protocol/mcontrol.h>
#include <protocol/mfunctions.h>

#define MODBUS_PORT		1
#define COM_PORT		0
#define BAUDRATE		9600
#define ADDRESS			1
#define PARITY			EVEN_PARITY
#define PROTOCOL		RTU_PROTOCOL
#define ASCII_DELIM		'\n'


mvregister mreg[2];

static int __attribute__((far))Holding_RegisterR1(mvregister *data)
{*data = mreg[0]; return 0;}

static int __attribute__((far))Holding_RegisterR2(mvregister *data)
{*data = mreg[1]; return 0;}

static int __attribute__((far))Holding_RegisterW1(mvregister *data)
{mreg[0] = *data; return 0;}

static int __attribute__((far))Holding_RegisterW2(mvregister *data)
{mreg[1] = *data; return 0;}

const mvregister_function HRR[] = {
	Holding_RegisterR1,
	Holding_RegisterR2
};

const mvregister_function HRW[] = {
	Holding_RegisterW1,
	Holding_RegisterW2		
};

int rc(){
	
	Modbus_Port *port = Modbus_Device_Open(MODBUS_PORT,BAUDRATE,
			ADDRESS,PARITY,PROTOCOL,ASCII_DELIM);
	
	ser_printf(COM_PORT,"simple modbus example\n\r");
	print_modbus_state(COM_PORT,port);
	MWR_SET(HRW);
	ser_printf(COM_PORT,"********holding registers read********\n\r");
	ser_dump_array(COM_PORT,MHRR_SET(HRR));

	ser_printf(COM_PORT,"initializing heartbeat\n\r");
	heartbeat(ON);			
	
	while(1)Modbus_Slave_Control(port);

	return 0;
}


